disableSerialization;

//Common variables
_dlg = findDisplay 513000;

_playerposx = (parseNumber ctrlText (_dlg displayCtrl 510000));
_playerposy = abs (sam_mapfix - (parseNumber ctrlText (_dlg displayCtrl 510001)));

_distance = (parseNumber ctrlText (_dlg displayCtrl 511101));
_direction = (parseNumber ctrlText (_dlg displayCtrl 511102));

_targetposx = (parseNumber ctrlText (_dlg displayCtrl 510002));
_targetposy = abs (sam_mapfix - (parseNumber ctrlText (_dlg displayCtrl 510003)));
_sam_zulu = (parseNumber ctrlText (_dlg displayCtrl 513004));

_targetPos = [_targetposx, _targetposy, 0];

// Creds to Bon_inf
_acdistance = sqrt (_distance^2 - _sam_zulu^2);
_calposx = round (_playerposx + _acdistance*sin(_direction));
_calposy = round (_playerposy + _acdistance*cos(_direction));

_samtype = lbCurSel 513001;

if (_samtype < 0) exitWith {player globalChat "SAM Support: No missiontype information"};

_missionType = ((sam_support select _samtype) select 1);

if ((_playerposx == 0) or (_playerposy == 0)) exitWith {player globalChat "SAM Support: No valid caller position information"};

//CAS
if (_missionType == 1) then {

if ((_targetposx == 0) or (_targetposy == 0)) exitWith {player globalChat "SAM Support: No valid target information. CAS needs E N coordinats."};

_cas = lbCurSel 513011;

if (_cas < 0) exitWith {player globalChat "SAM Support: No unit selected"};
_sam_cas = ((sam_cas select _cas) select 1);
_sam_cas_name = ((sam_cas select _cas) select 0);
_sam_cas_pad = ((sam_cas select _cas) select 2);

if(!alive _sam_cas) exitWith {player globalChat format ["SAM Support: No contact with %1", _sam_tp_name]};

if (_sam_cas isKindOf "Plane") then { 
player globalChat "SAM Support: CAS request sent, standby";
 
if ((speed _sam_cas) < 1) then { 

_sam_cas_calls = (server getVariable "sam_cas_calls");

server setVariable ["sam_cas_calls", ((server getVariable "sam_cas_calls") + 1), true];
	
if ((server getVariable "sam_cas_calls") > sam_cas_calls) exitWith {player globalChat "SAM Support: No calls for CAS left"};

if (samcast == 5) exitWith {player globalChat format ["%1 says No ACE no CBU sorry!", _sam_cas_name];};

if (samcasttarget == 1) then {
_targetPos = getPos ((nearestObjects [_targetPos, ["Car","Truck"], 100]) select 0)};
if (samcasttarget == 2) then {
_targetPos = getPos ((nearestObjects [_targetPos, ["Tank"], 100]) select 0)};
if (samcasttarget == 3) then {
_targetPos = getPos ((nearestObjects [_targetPos, ["House"], 100]) select 0)};

if (IsNil "samcast") then {samcast = 0};
server setVariable ["sam_cas_req", [1, samcast, _sam_cas, _sam_cas_name, _sam_cas_pad, _targetPos], true];

sleep sam_airmission_delay + (random 40);
player globalChat format ["SAM Support: %1 en route to target area", _sam_cas_name];
if (samcast == 0) then { 
	waitUntil {(_sam_cas distance _targetPos)< 2000};
	player globalChat format ["%1: Entering area", _sam_cas_name];
	waitUntil {(_sam_cas distance _targetPos)<1000};
	sleep sam_fixedwing_time; 
	player globalChat format ["SAM Support: %1 RTB", _sam_cas_name];
};

if (samcast == 1) then { 
	waitUntil {(_sam_cas distance _targetPos)< 2000};
	player globalChat format ["%1: Entering target area", _sam_cas_name];
	waitUntil {(_sam_cas distance _targetPos)<1000};
	sam_evhf = _sam_cas addEventHandler ["fired", {_this execVM "sam_support\deleteevh.sqf"}];
	sleep sam_fixedwing_time;  
	player globalChat format ["SAM Support: %1 RTB", _sam_cas_name];
};

if (samcast == 2) then { 
	waitUntil {(_sam_cas distance _targetPos)<2000};
	player globalChat format ["%1: Entering target area", _sam_cas_name];
	waitUntil {(_sam_cas distance _targetPos)<1000};
	sam_evhf = _sam_cas addEventHandler ["fired", {_this execVM "sam_support\deleteevh.sqf"}];
	sleep sam_fixedwing_time; 
	player globalChat format ["SAM Support: %1 RTB", _sam_cas_name];
};

if (samcast == 3) then { 
	waitUntil {(_sam_cas distance _targetPos)<2000};
	player globalChat format ["%1: Entering target area", _sam_cas_name];
	waitUntil {(_sam_cas distance _targetPos)<1000};
	sam_evhf = _sam_cas addEventHandler ["fired", {_this execVM "sam_support\deleteevh.sqf"}];
	sleep sam_fixedwing_time; 
	player globalChat format ["SAM Support: %1 RTB", _sam_cas_name];
};

if (samcast == 4) then { 
	waitUntil {(_sam_cas distance _targetPos)<2000};
	player globalChat format ["%1: Entering target area", _sam_cas_name];
	waitUntil {(_sam_cas distance _targetPos)<1000};
	sam_evhf = _sam_cas addEventHandler ["fired", {_this execVM "sam_support\deleteevh.sqf"}];
	sleep sam_fixedwing_time; 
	player globalChat format ["SAM Support: %1 RTB", _sam_cas_name];
	};


} else {  player globalChat format ["SAM Support: %1 not available", _sam_cas_name]};

}else{
player globalChat "SAM Support: CAS request sent, standby";
sleep 2;
if (((_sam_cas_pad distance _sam_cas) < 25)  && (alive _sam_cas)) then {

server setVariable ["sam_cas_calls", ((server getVariable "sam_cas_calls") + 1), true];
	
if ((server getVariable "sam_cas_calls") > sam_cas_calls) exitWith {player globalChat "SAM Support: No calls for CAS left"};
	server setVariable ["sam_cas_req", [1, samcast, _sam_cas, _sam_cas_name, _sam_cas_pad, _targetPos], true];
	sleep sam_airmission_delay + (random 40);
	player globalChat format ["SAM Support: %1 en route to target area", _sam_cas_name];
	sleep 10;
	waitUntil {(_sam_cas distance _targetPos)< 1500};
	player globalChat format ["%1: Entering target area", _sam_cas_name];
	sam_evhf = _sam_cas addEventHandler ["fired", {_this execVM "sam_support\deleteevh.sqf"}];
	sleep sam_rotarywing_time;
	player globalChat format ["SAM Support: %1 RTB", _sam_cas_name];
	waitUntil {(_sam_cas distance _sam_cas_pad) < 100};
	} else { player globalChat format ["SAM Support: %1 not available", _sam_cas_name]};
	};
};

//Arty
if ((_missionType == 2)) then {

if (((_targetposx == 0) or (_targetposy == 0)) and (_distance == 0)) exitWith {player globalChat "SAM Support: No valid target information"};
if (_direction > 360) exitWith {player globalChat "SAM Support: No valid direction"};

_battery = lbCurSel 513003;
if (_battery < 0) exitWith {player globalChat "SAM Support: No unit selected"};
_batterydname = ((sam_batterys select _battery) select 0);
_batteryname = ((sam_batterys select _battery) select 1);
_batterytype = ((sam_batterys select _battery) select 2);

_sam_delay = (parseNumber ctrlText (_dlg displayCtrl 513005));
_sam_shells = (parseNumber ctrlText (_dlg displayCtrl 513006));
_sam_dispersion = (parseNumber ctrlText (_dlg displayCtrl 513007));

if (sam_dispersion == 1) then {
if (_sam_dispersion != 0) then {
if (_sam_dispersion < 25) then {_sam_dispersion = 25 + random 50};
	};
};

_targetPos = [_targetposx, _targetposy, _sam_zulu];
_calpos = [_calposx, _calposy, _sam_zulu];

if ((_batteryname getVariable "ARTY_ONMISSION")) then {player globalChat format["SAM Support: %1 not available", _batterydname];} else {

if (_batterytype == 2) then {
if (samam == 0) then { sam_sammo = "HE"};
if (samam == 1) then { sam_sammo = "WP"};
if (samam == 2) then { sam_sammo = "ILLUM"};
if (samam == 3) then { sam_sammo = "SMOKE"};
if (samam == 5) then { sam_sammo = "laser"};
if (samam == 4) then { sam_sammo = "sadarm"};
};
if(_batterytype == 1) then {
if (samam == 0) then { sam_sammo = "HE"};
if (samam == 1) then { sam_sammo = "WP"};
if (samam == 2) then { sam_sammo = "ILLUM"};
if (samam == 3) then { sam_sammo = "FAIL"};
if (samam == 4) then { sam_sammo = "FAIL"};
if (samam == 5) then { sam_sammo = "FAIL"};
};
if(_batterytype == 3) then {
if (samam == 0) then { sam_sammo = "HE"};
if (samam == 1) then { sam_sammo = "FAIL"};
if (samam == 2) then { sam_sammo = "FAIL"};
if (samam == 3) then { sam_sammo = "FAIL"};
if (samam == 4) then { sam_sammo = "FAIL"};
if (samam == 5) then { sam_sammo = "FAIL"};
};

if (sam_maxshells < _sam_shells) exitWith {player globalChat format["SAM Support: To many shells, max shells %1", sam_maxshells]};
if (sam_sammo == "FAIL") exitWith {player globalChat format["SAM Support: This munition type is not available for  %1", _batterydname]};

_heTemplate = ["IMMEDIATE", sam_sammo, _sam_delay, _sam_shells];

_alive = [_batteryname, _heTemplate] call BIS_ARTY_F_StillViable;

if (! _alive) exitWith {player globalChat format["SAM Support: No contact with %1", _batterydname]};

_pos = if ((_distance)  != 0) then {_calpos} else {_targetpos};

if ((server getVariable "sam_arty_calls") > sam_arty_calls) exitWith {player globalChat "SAM Support: No calls for artillery left"};

[_batteryname, _pos, sam_sammo] execVM "sam_support\fnc_TargetETA.sqf";

server setVariable ["sam_arty_calls", ((server getVariable "sam_arty_calls") + 1), true];

player globalChat format ["SAM support: Sending firemission to %1", _batterydname];
sleep sam_artymission_delay + (random 15);

server setVariable ["sam_firemission_req", [1, [_batteryname, true], [_batteryname, _sam_dispersion], [_batteryname, _pos, _heTemplate], _sam_dispersion], true];

player globalChat format["%1: Firemission recived.", _batterydname];

_sam_time_of_flight = switch (_batterytype) do {case 1: {sam_time_of_flight}; case 2 : {sam_time_of_flight - 2}; case 3: {sam_time_of_flight - 10};};

if (_sam_time_of_flight < 0) exitWith {player globalChat format["%1: Firemission canceled, cant hit target pos", _batterydname]; server setVariable ["sam_arty_calls", ((server getVariable "sam_arty_calls") - 1), true];};

waitUntil {_batteryname getVariable "ARTY_ONMISSION"};

waitUntil {_batteryname getVariable "ARTY_SHOTCALLED"};
player globalChat format["%1: Shot! ToF %2 sec", _batterydname, (round _sam_time_of_flight)];

if ( sam_sammo == "laser") then {[_batterydname, _sam_time_of_flight] execVM "sam_support\laser.sqf"};

waitUntil {_batteryname getVariable "ARTY_COMPLETE"};
player globalChat format["%1: Rounds complete", _batterydname];

waitUntil {_batteryname getVariable "ARTY_SPLASH"};
player globalChat format["%1: Splash", _batterydname];

_batteryname setVariable ["ARTY_BADTARGET", null, true];
	};
};

//UAV
if (_missionType == 3) then {

if ((_targetposx == 0) or (_targetposy == 0)) exitWith {player globalChat "SAM Support: No valid target area information. AC130 missions needs E N coordinats."};

_sam_uav_calls = player getVariable "sam_AC130_calls";

server setVariable ["sam_uav_calls", ((server getVariable "sam_uav_calls") + 1), true];
	
if ((server getVariable "sam_uav_calls") > sam_uav_calls) exitWith {player globalChat format ["SAM Support: UAV no longer available"]};

player globalChat "SAM Support: UAV request sent, standby";
sleep sam_airmission_delay + (random 40);

if ((server getVariable "sam_uav_req") == 1) exitWith {player globalChat "SAM Support: UAV already in air"}; 

player globalChat "SAM Support: UAV request approved";
[_targetpos, LDL_options select 0, LDL_options select 1, LDL_options select 21, LDL_options select 20]call LDL_uav_rot_setup;

server setVariable ["sam_uav_req", 1, true];
sleep ((LDL_options select 14) + 120);
server setVariable ["sam_uav_req", 0, true];
};

//Transport
if (_missionType == 4) then {

if ((_targetposx == 0) or (_targetposy == 0)) exitWith {player globalChat "SAM Support: No valid RV point information. Transport missions needs E N coordinats."};

_tp = lbCurSel 513013;
if (_tp < 0) exitWith {player globalChat "SAM Support: No unit selected"};
_sam_tp = ((sam_transport select _tp) select 1);
_sam_tp_name = ((sam_transport select _tp) select 0);
_sam_tp_pad = ((sam_transport select _tp) select 2);

if(!alive _sam_tp) exitWith {player globalChat format ["SAM Support: No contact with %1", _sam_tp_name]};

player globalChat "SAM Support: Transport request sent, standby";
if ((_sam_tp_pad distance _sam_tp) < 25) then {

sleep sam_airmission_delay + (random 40);
server setVariable ["sam_tp_req", [1, _sam_tp, _sam_tp_name, _sam_tp_pad, _targetPos, samtpmark], true];
player globalChat format ["SAM Support: %1 en route to RV point", _sam_tp_name];
waitUntil {(_sam_tp distance _sam_tp_pad)>100};
waitUntil {(_sam_tp distance _targetpos)<1500};
if ((samtpmark > 0)) then {
player globalChat format ["%1: Mark LZ", _sam_tp_name];};
sleep 2;
if ((landResult _sam_tp) == "NotFound") then {
	player globalChat format ["SAM Support: %1 cant find a good LZ", _sam_tp_name];};
	waitUntil {(getPosATL _sam_tp) select 2 < 9};
	player globalChat format ["%1: At RV point", _sam_tp_name];
	sleep sam_rotarywing_timeonground + random 10;

	} else { player globalChat format ["SAM Support: %1 not available", _sam_tp_name]};
};

//AC-130
if (_missionType == 5) then {

if ((_targetposx == 0) or (_targetposy == 0)) exitWith {player globalChat "SAM Support: No valid target area information. AC130 missions needs E N coordinats."}; 

if ((server getVariable "sam_ac130_req") == 1) exitWith {player globalChat "SAM Support: AC-130 already in air"}; 

_sam_ac130_calls = player getVariable "sam_AC130_calls";

server setVariable ["sam_ac130_req", ((server getVariable "sam_ac130_calls") + 1), true];

if ((server getVariable "sam_ac130_calls") > sam_ac130_calls) exitWith {player globalChat format ["SAM Support: AC-130 no longer available"]};

player globalChat "SAM Support: AC-130 request sent, standby";
sleep sam_airmission_delay + (random 40);

player globalChat "SAM Support: AC-130 request approved";
[_targetpos, LDL_options select 0,LDL_options select 1,LDL_options select 14, LDL_options select 20] call LDL_ac130_AI_setup;

server setVariable ["sam_ac130_req", 1, true];
sleep ((LDL_options select 14) + 120);
server setVariable ["sam_ac130_req", 0, true];

};

