//SAM SUPPORT by Nordin
//--------------------------------------------------------------------------------------------------------------------\\
//Type of support ["Displayname", type] Type = 1 CAS, 2 Artillery, 3 UAV, 4 Transport, 5 AC-130
sam_support = [["CAS", 1], ["Artillery", 2], ["UAV", 3], ["Transport", 4], ["AC-130", 5]];

//Users
sam_support_users = [test];

//--------------------------------------------------------------------------------------------------------------------\\
//Artillery

//Batterys [Displayname, artymodule name, type of artillery] Artillery type 1 = Mortar 2 = Howitzer 3 = MLRS
sam_batterys = [["Ripper", ripper1, 1], ["Steel rain", ripper2, 2], ["Chaos", chaos, 3]];

//Max shells that can be delivered at one time
sam_maxshells = 10;

//Allow player to set dispersion
sam_dispersion = 1;

//Delay for arty mission to be approved
sam_artymission_delay = 10;

//Artillery calls
sam_arty_calls = 4;

//--------------------------------------------------------------------------------------------------------------------\\
//CAS

//Callsigns and units for CAS ["Displayname", unitname, helipad assigned to heli]
sam_cas = [["Warthog 12", a10], ["Bushmaster 5", ah64, h1]];

//Time in target area for planes
sam_fixedwing_time = 200;

//Time in target area for helicopters
sam_rotarywing_time = 200;

//Home airport
sam_airport = 1;

//Delay for airmission to be approved
sam_airmission_delay = 10;

//CAS calls
sam_cas_calls = 2;

//--------------------------------------------------------------------------------------------------------------------\\
//Transport

//Callsigns and units for transport ["Displayname", unitname, helipad assigned to heli]
sam_transport = [["Hawk", uh60, h2], ["Nazgul", hc4, h3]];

//Time on ground for transportheli
sam_rotarywing_timeonground = 40;

//Transport calls
sam_tp_calls = 2;

//Smoke type. Can be = SmokeShellGreen, SmokeShell, SmokeShellYellow, SmokeShellRed, SmokeShellPurple, SmokeShellBlue, SmokeShellOrange 
sam_smoke_tp = "SmokeShellGreen";

//--------------------------------------------------------------------------------------------------------------------\\
//UAV
sam_uav_calls = 3;

//--------------------------------------------------------------------------------------------------------------------\\
//AC130
sam_AC130_calls = 1;

//--------------------------------------------------------------------------------------------------------------------\\
//INFO
sam_info_text = "<br/><br/>Ripper = US mortar <br/>Steel Rain = M119 <br/>Chaos = MLRS <br/>Warthog 12 = A10 <br/>Bushmaster 5 = AH64 <br/>Hawk = UH60 <br/>Nazgul = CH47";

//--------------------------------------------------------------------------------------------------------------------\\
//No edit

//Delete target evh
{if (_x select 1 isKindOf "Plane") then {_x select 1 addEventhandler ["fired", {_this execVM "sam_support\sam_delete.sqf"}];};} forEach sam_cas;

//Setting standard variables
if (IsServer or isDedicated) then {execVM "sam_support\server_cas.sqf"; execVM "sam_support\server_art.sqf"; execVM "sam_support\server_transport.sqf"; server setVariable ["sam_arty_calls", 0, true]; server setVariable ["sam_cas_calls", 0, true]; 
server setVariable ["sam_uav_calls", 0, true]; server setVariable ["sam_ac130_calls", 0, true]; server setVariable ["sam_ac130_req", 0, true]; server setVariable ["sam_uav_req", 0, true]; 
server setVariable ["sam_support_use", 0, true]};

//Mapfix for position 5120 for Utes, 15360 for Chernu, 0 for OA maps 
sam_mapfix = switch (worldName) do {case "chernarus": {15360}; case "utes": {5120}; default {0};};

//Add action
{_x addAction ["SAM Support", "sam_support\GUI\o.sqf"]; _x addEventHandler ["killed", {_this execVM "sam_support\respawn.sqf"}]} forEach sam_support_users;